
public abstract class Duck {

    public Duck() {
    }

    abstract void display();

    public void swim() {
        System.out.println("All ducks float, even decoys!");
    }

    public static void main(String [] args)
    {
        Duck [] ducks = new Duck[4];
        ducks[0] = new MallardDuck();
        ducks[1] = new RedHeadDuck();
        ducks[2] = new RubberDuck();
        ducks[3] = new DecoyDuck();

        for (Duck d : ducks)
        {
            d.display();
            
            if (d instanceof Quackable)
                ((Quackable) d).quack();
            if (d instanceof Flyable)
                ((Flyable) d).fly();
            
            System.out.println();
        }       
    }
}
